PROCEDURE ToQP(lcText)
LOCAL lcRet,lcChar,lii,liChar,liEnter,liy
lcRet=""
liEnter=0
FOR lii = 1 TO LEN(lcText)
    lcChar = SUBST(lcText,lii, 1)
    liChar=ASC(lcChar)

    IF (liChar>= 33 AND liChar<= 60) OR (liChar>= 62 AND liChar<= 126)
       lcRet=lcRet+lcChar
       liEnter=liEnter+1
    ELSE
       lcRet=lcRet+"=" + RIGHT(TRANSFORM(liChar,"@0"),2)
       liEnter=liEnter+3
    ENDIF

    IF liEnter=60
       liEnter=0
       lcRet=lcRet+CRLF
    ELSE
       IF liEnter>60
          lcRet=STUFF(lcRet,LEN(lcRet)-2,0,CRLF)
          liEnter=3
       ENDIF
    ENDIF
NEXT
RETURN lcRet
ENDPROC


   PROCEDURE _toSMTP(loSMTP)
      LOCAL loThread,lcKey,lcFrom,lcTo,lcSubject,lcHTML
      lcKey=SYS(2015)+":"+SYS(2015)+":"+SYS(2015)

      lcFrom=CHRTRAN(loSMTP.From,"@","%")
      IF !EMPTY(This.SMTP_From)
         liy=ATC("%namereply%",This.SMTP_From)
         IF liy>0
            lcFrom=STUFF(This.SMTP_From,liy,LEN("%namereply%"),CHRTRAN(loSMTP.oSP.Conf,"@","%"))
         ELSE
            lcFrom=This.SMTP_From
         ENDIF
      ENDIF

      liy=ATC("%dnsreply%",lcFrom)
      DO CASE

         CASE !EMPTY(This.SMTP_DNSReply) AND EMPTY(This.SMTP_From)
              lcFrom=lcFrom+"@"+This.SMTP_DNSReply

         CASE !EMPTY(This.SMTP_DNSReply) AND !EMPTY(This.SMTP_From) AND liy>0
              lcFrom=STUFF(lcFrom,liy,LEN("%dnsreply%"),This.SMTP_DNSReply)

      ENDCASE

      lcTo=CHRTRAN(LEFT(loSMTP.To,AT("@",loSMTP.To)-1),"%","@")

      lcSubject=""
      IF LEN(loSMTP.Subject)>0
         lcSubject=This.SubjectToQP(loSMTP.Subject)
      ENDIF

      loThread=CREATEOBJECT("_thr_smtp")
      loThread.oSP=m.loSMTP.oSP
      loThread.Header="RSET"+CRLF+;
                      "MAIL FROM: "+lcFrom+CRLF+;
                      "RCPT TO: "+lcTo+CRLF+;
                      "DATA"

      lcTZ=REPLICATE(CHR(0),172)
      =GetTimeZoneInformation(@lcTZ)

*                    "Message-ID: <"+IIF(EMPTY(m.loSMTP.ID),SYS(2015)+"."+SYS(2015), m.loSMTP.ID)+SUBST(lcFrom,AT("@",lcFrom))+">"+CRLF+;
*


      loThread.Body="MIME-Version: 1.0"+CRLF+;
                    "To: "+lcTo+CRLF+;
                    "From: "+lcFrom+CRLF+;
                    "X-Mailer: VisualFoxPro-Jabber-SMTP-Transport"+CRLF+;
                    "Subject: "+IIF(LEN(lcSubject)>0,lcSubject,"")+CRLF+;
                    "Date: "+SUBSTR(_days, (DOW(DATE(),0)-1)*3+1,3 )+", "+;
                             CHRTRAN(STR(DOW(DATE(),0),2)," ","0")+" "+;
                             SUBSTR(_months, (MONTH(DATE())-1)*3+1,3 )+" "+;
                             STR(YEAR(DATE()),4)+" "+TIME()+" +"+;
                             CHRTRAN(STR(ABS(C4ToL(LEFT(lcTZ,4))/60),2)+"  "," ","0")+CRLF

      DO CASE
         CASE !EMPTY(loSMTP.Body) AND !EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            [Content-type: multipart/alternative; boundary="]+lcKey+["]+CRLF+;
                            CRLF+;
                            "--"+lcKey+CRLF+;
                            "Content-Type: text/plain; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber text message"+CRLF+;
                            CRLF+;
                            loSMTP.Body+CRLF+;
                            CRLF+;
                            "--"+lcKey+CRLF+;
                            "Content-Type: text/html; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber html message"+CRLF+;
                            CRLF+;
                            loSMTP.html+CRLF+;
                            ""+CRLF+;
                            "--"+lcKey+"--"+CRLF+;
                            ""+CRLF+;
                            "."+CRLF+CRLF


         CASE !EMPTY(loSMTP.Body) AND EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            "Content-Type: text/plain; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber text message"+CRLF+;
                            CRLF+;
                            loSMTP.Body+CRLF+;
                            CRLF+;
                            "."+CRLF+CRLF

         CASE EMPTY(loSMTP.Body) AND !EMPTY(loSMTP.html)
              loThread.Body=loThread.Body+;
                            "Content-Type: text/html; charset=utf-8"+CRLF+;
                            "Content-Transfer-Encoding: 8bit"+CRLF+;
                            "Content-Description: Jabber html message"+CRLF+;
                            CRLF+;
                            loSMTP.html+CRLF+;
                            CRLF+;
                            "."+CRLF+CRLF

      ENDCASE
      =This.tmrThreads.AddThread(loThread)
   ENDPROC

